<?
/*
  ##############################
  Internet Personal Branding Kit
  Danny Dover - SEOmoz.org

  Please note: We do NOT provide
  support for this product.
  Everything you will need is
  in README files.
  ##############################

  ##############################
  Modified for multibyte environment
  Hidehisa YASUDA - web-tan
  ##############################
*/

define('ENCODING_FROM', 'EUC-JP,SJIS,UTF-8,JIS');
define('ENCODING_TO', 'UTF-8');


//recursive function that prints out img source code based on the provided $path
//second parameter is a boolean of whether or not photos should be in individual class="box"
//fourth parameter is the name of the owner of the site. This changes the format of the alt attribute to (name) in (filename). Ex. John Doe in Wired
function print_images($path, $add_box) {
  
  $div_tag_open = false;
  
  //if given node is a file (as opposed to a directory)
  if(!is_dir($path)){
        
    //get file name
    $path_array = explode('/', $path);
    $last_element = $path_array[count($path_array) - 1];
    
    //remove file extension from filename string to produce alt text
    $file_name_array = explode('.', $last_element);
    $alt_text = htmlspecialchars(mb_convert_encoding($file_name_array[0], ENCODING_TO, ENCODING_FROM));
    
    // need to urlencode multibyte element in path
    foreach($path_array as $path_key=>$path_value){
      $path_array[$path_key] = rawurlencode($path_value);
    }
    $fig_path = implode('/', $path_array);

    if($add_box) {
      echo "\t\t\t\t\t<div class='box'> <img src=\"$fig_path\" alt=\"$alt_text\" /> </div> \n";
    } else {
      echo "\t\t\t\t<img src=\"$fig_path\" alt=\"$alt_text\" /> \n";
    } 

  //else is a directory 
  } else {
  
    if ($handle = opendir($path)) {
            
        while ($file = readdir($handle)) {
            if ($file != "." && $file != ".." && $file != ".DS_Store" && $file != "README.txt") {
                
          //If Directory, print title
          if (is_dir($path . "/" . $file)){
            
            if($div_tag_open){
              print("\t\t\t\t</div> \n");
              $div_tag_open = false;
            }
            
            print("\t\t\t\t<div class='span-18'> \n");
            $div_tag_open = true;
            print("\t\t\t\t\t<h2>" . htmlspecialchars(mb_convert_encoding($file, ENCODING_TO, ENCODING_FROM)) . "</h2> \n" );
          }
          print_images($path . "/" . "$file", $add_box);  
            }
        }
        closedir($handle);
    }
    if($div_tag_open){
      print("\t\t\t\t</div>");
    }
  }
}

//function that prints all of the lines ina file into a unordered list
//second parameter is a boolean of whether or not to append "box" layout
function print_text($file_location, $add_box, $add_bullets, $add_p) {
  $file = fopen($file_location, 'r');

  if ($file) {

    if($add_bullets){
      echo("\t\t\t\t\t<ul>\n");
      while (!feof($file)) {
        $buffer = trim(fgets($file, 4096));
        if($add_box){
          echo("\t\t\t\t<li class='box'>" . $buffer . "</li> \n");
        } else {
          echo("\t\t\t\t\t\t<li>" . $buffer . "</li>\n");
        }
      }
      echo("\t\t\t\t\t</ul>\n");
    } else {
      while (!feof($file)) {
        $buffer = fgets($file, 4096);
        if($add_box){
          echo("\t\t\t\t<p class='box'>" . $buffer . "</p>\n");
        } else {
          if ($add_p) {
            echo("\t\t\t\t\t<p>" . $buffer . "</p>\n");
          } else {
            echo("\t\t\t\t" . $buffer . "\n");
          }         
        }
      }     
    }
  }
  fclose($file);
}

//function to print sections based on file structure and content
//second parameter dictates bullet inclusion
//third parameter dictates span-18 inclusion
function print_sections($directory_location, $bullets_and_title, $wrap_in_span, $add_p) {

  // Open the folder 
  $dir_handle = @opendir($directory_location) or die("Cannot open the directory $directory_location"); 
  $file_names[] = null;

  // Lookup file (Note: this needs to be a while or continue; will not work)
  while ($file = readdir($dir_handle)) { 

    //ignore system files
    if($file == "." || $file == ".." || $file == ".DS_Store" || $file == "README.txt") 

    continue;

    //Break filename into parts with extension in last node and filename in first node
    $file_name_array = explode('.', $file);
    $proper_file_name = mb_convert_encoding($file_name_array[0], ENCODING_TO, ENCODING_FROM);

    $URI = $directory_location . "/" . $file;
    
    if($bullets_and_title){
      print("\t\t\t\t<div class='span-18 bullet-section'> \n");
      print("\t\t\t\t\t<h2>" . $proper_file_name . "</h2>\n");
      print_text($URI, false, true, false);
      print("\t\t\t\t</div>\n");
    } else if ($wrap_in_span){
      print("\t\t\t\t<div class='span-18 span-section'> \n");
      print_text($URI, false, false, true);
      print("\t\t\t\t</div>\n");
    } else {
      print_text($URI, false, false, false);
    }
    //reset array
    $file_name_array = null;
  }
  // Close 
  closedir($dir_handle);
}